(function ( $ ) {
 	//oni okashira
	passwordValidator = function( options ) {
	
		// This is the easiest way to have default options.
		var settings = $.extend({
			// These are the defaults.
			target:'.pass',
			controlContainer:'body'
		}, options );
		
		var uppercase = "Include an <strong class='pw-highlight'>uppercase</strong> character";
		var lowercase = "Include a <strong class='pw-highlight'>lowercase</strong> character";
		var digit = "Include a <strong class='pw-highlight'>number</strong>";
		var special = "Include a special characters <strong class='pw-highlight'># ? ! @ $ % ^ & * ( ) _ + - =</strong>";
		var count = "Be at least <strong class='pw-highlight'>8 characters</strong>";
		
		
		$(settings.controlContainer).append("<div><strong>Your password must:</strong></div>");
		$(settings.controlContainer).append("<div class='pw-uppercase'>"+uppercase+"</div>");
		$(settings.controlContainer).append("<div class='pw-lowercase'>"+lowercase+"</div>");
		$(settings.controlContainer).append("<div class='pw-digit'>"+digit+"</div>");
		$(settings.controlContainer).append("<div class='pw-special'>"+special+"</div>");
		$(settings.controlContainer).append("<div class='pw-count'>"+count+"</div>");
		
		
		$(settings.target).on("keyup", function () { 
			var pass = $(this).val();
			
			checkUpperCase(pass);
			checkLowerCase(pass);
			checkDigit(pass);
			checkSpecial(pass);
			checkCount(pass);

			if (checkUpperCase(pass) && checkLowerCase(pass) && checkDigit(pass) && checkSpecial(pass) && checkCount(pass))
			    $(settings.controlContainer).hide();
            else
			    $(settings.controlContainer).show();
		});
		
		function checkUpperCase(pass){
		    if ((!!/[A-Z]/.exec(pass))) {
		        $('.pw-uppercase').html("");
		        return true;
		    } else {
		        $(settings.controlContainer).show();
		        $('.pw-uppercase').html(uppercase);
		        return false;
		    }
		}
		
		function checkLowerCase(pass){
		    if ((!!/[a-z]/.exec(pass))) {
		        $('.pw-lowercase').html("");
		        return true;
		    } else {
		        $(settings.controlContainer).show();
		        $('.pw-lowercase').html(lowercase);
		        return false;
		    }
		}
		
		function checkDigit(pass){
		    if ((!!/[0-9]/.exec(pass))) {
		        $('.pw-digit').html("");
		        return true;
		    } else {
		        $(settings.controlContainer).show();
		        $('.pw-digit').html(digit);
		        return false;
		    }
		}
		
		function checkSpecial(pass){
		    if ((!!/(?=.*?[#?!@$%^&*\-\=+()_])/.exec(pass))) {
		        $('.pw-special').html("");
		        return true;
		    } else {
		        $(settings.controlContainer).show();
		        $('.pw-special').html(special);
		        return false;
		    }
		}
		
		function checkCount(pass){
		    if ((!!/.{8,}/.exec(pass))) {
		        $('.pw-count').html("");
		        return true;
		    } else {
		        $(settings.controlContainer).show();
		        $('.pw-count').html(count);
		        return false;
		    }
		}
	};
 
}( jQuery ));